<?php
namespace OrganizationsManagement\Factory;
use Teknisa\Model\Teknisa\Entities\OmProdutoOrgElementoContrato;
use OrganizationsManagement\Util\Utilities as Utilities;
use Teknisa\Model\Util\NovoCodigo as NovoCodigo;

class ProdutoOrgElementoContrato {

    public function save($orgElementoId, $nrseqcontrato, $currentOrgId,  $dateNow, $codOperador, $idAtivo = 'S')
    {
        $entity = new OmProdutoOrgElementoContrato();
        $novoCodigo = NovoCodigo::geraCodigo($currentOrgId, "OM_PRODUTO_ORG_ELEMENTO_CONTRATO", 1, 10, false, false);
        $entity->setId($novoCodigo ? $novoCodigo : 1);
        $entity->setCdoperinclusao($codOperador);
        $entity->setCdoperultatu($codOperador);
        $entity->setDtinclusao($dateNow);
        $entity->setDtultatu($dateNow);
        $entity->setIdativo($idAtivo);
        $entity->setNrorg($currentOrgId);
        $entity->setNrorginclusao($currentOrgId);
        $entity->setNrorgultatu($currentOrgId);
        $entity->setNrprodutoElementoId($orgElementoId);
        $entity->setNrseqcontrato($nrseqcontrato);

        return $entity;
    }
}
