<?php

namespace OrganizationsManagement\Repository;

use OrganizationsManagement\Util\InstanceProvider;
use OrganizationsManagement\Util\Utilities;




class SendAlertSla
{


    public function getCallAlerts(){

        $query = <<<SQL
           
          SELECT CPC.NRCALL,SCI.ID_RESP_PROD_ESTRUT, CPC.TYPE,SCI.IDANTESDEPOIS,NVL(TAS.NAME, SOL.DSREFESOLI) AS NAME, CPC.CALL_RELATIONSHIP,VST.STRUCTURE_NAME,VST.ID_STRUCTURE,SCI.STRUCTURE_TYPE_ID ,CLT.NMFANTCLIE, CLT.CDCLIENTE,ROUND(CPC.QTSLA_TOT_TEK,2) AS QTSLA_TOT_TEK,ROUND(QTSLA_ESPECIFICACAO,2) AS QTSLA_ESPECIFICACAO, ROUND(CPC.QT_SLA_CONTRATO,2) AS QT_SLA_CONTRATO , SCI.QTHORASALERT,SCI.CDGRUPFASE,
           ( CPC.NRCALL||' ('||CPC.TYPE ||'-'||CPC.CALL_RELATIONSHIP||')') AS ID_CALL,
           (CASE SCI.STRUCTURE_TYPE_ID 
            WHEN 1 THEN (SELECT RTRIM(XMLAGG(XMLELEMENT(e,ORG.DSEMAILOPER ,',').EXTRACT('//text()')).GetClobVal(),',')  AS EMAIL  FROM ORGANIZACAO ORG WHERE NRORG = VST.ID_ORGANIZATION)
            WHEN 5 THEN (SELECT RTRIM(XMLAGG(XMLELEMENT(e,RES.EMAIL ,',').EXTRACT('//text()')).GetClobVal(),',')  AS EMAIL FROM PERMISSION PER JOIN RESOURCE_T RES ON (RES.ID = PER.RESOURCE_T AND RES.STATUS = 'A') WHERE TYPE = 'M' AND RES.EMAIL IS NOT NULL AND PER.STRUCTURE = VST.ID_EQUIPE)
            WHEN 17 THEN (SELECT RTRIM(XMLAGG(XMLELEMENT(e,RES.EMAIL ,',').EXTRACT('//text()')).GetClobVal(),',')  AS EMAIL FROM PERMISSION PER JOIN RESOURCE_T RES ON (RES.ID = PER.RESOURCE_T AND RES.STATUS = 'A') WHERE TYPE = 'M' AND RES.EMAIL IS NOT NULL AND PER.STRUCTURE = VST.ID_SETOR)
            WHEN 23 THEN (SELECT RTRIM(XMLAGG(XMLELEMENT(e,RES.EMAIL ,',').EXTRACT('//text()')).GetClobVal(),',')  AS EMAIL FROM PERMISSION PER JOIN RESOURCE_T RES ON (RES.ID = PER.RESOURCE_T AND RES.STATUS = 'A') WHERE TYPE = 'M' AND RES.EMAIL IS NOT NULL AND PER.STRUCTURE = VST.ID_DEPARTAMENTO)
            WHEN 25 THEN (SELECT RTRIM(XMLAGG(XMLELEMENT(e,RES.EMAIL ,',').EXTRACT('//text()')).GetClobVal(),',')  AS EMAIL FROM PERMISSION PER JOIN RESOURCE_T RES ON (RES.ID = PER.RESOURCE_T AND RES.STATUS = 'A') WHERE TYPE = 'M' AND RES.EMAIL IS NOT NULL AND PER.STRUCTURE = VST.ID_PRESIDENCIA)
            WHEN 26 THEN (SELECT RTRIM(XMLAGG(XMLELEMENT(e,RES.EMAIL ,',').EXTRACT('//text()')).GetClobVal(),',')  AS EMAIL FROM PERMISSION PER JOIN RESOURCE_T RES ON (RES.ID = PER.RESOURCE_T AND RES.STATUS = 'A') WHERE TYPE = 'M' AND RES.EMAIL IS NOT NULL AND PER.STRUCTURE = VST.ID_DIRETORIA)
            ELSE TO_CLOB ('Tipo de estrutura desconhecido!')
            END) AS STRUCTURE_EMAIL,
            CLA1.LABEL AS LABEL_CLASSIFICATION,
           (CASE CPC.TYPE 
             WHEN 'I' THEN PRT.NAME||'(Mobile)'
             WHEN 'S' THEN PRC.NMPRODUTO||'(Delphi)'
              ELSE 'Nome do produto desconhecido!'
            END) AS PRODUCT_NAME,
            (CASE SLP.ID_CONTROLA_SLA 
             WHEN 'S' THEN CLT.NMFANTCLIE||' (CONTRATO)'
             ELSE CLT.NMFANTCLIE
            END) AS CLIENT_NAME,
            (CASE CPC.TYPE 
             WHEN 'I' THEN (SELECT RTRIM(XMLAGG(XMLELEMENT(e,RES.EMAIL ,',').EXTRACT('//text()')).GetClobVal(),',')  AS EMAIL FROM RESOURCE_PROJECT REP JOIN RESOURCE_T RES ON (REP.RESOURCE_C = RES.ID AND RES.STATUS = 'A'AND RES.EMAIL IS NOT NULL ) WHERE REP.TYPE = 'M' AND REP.PROJECT = TAS.PROJECT)
             WHEN 'S' THEN TO_CLOB (OPR.DSEMAILOPER)
              ELSE TO_CLOB ('Tipo de chamado desconhecido!')
            END) AS PRODUCT_EMAIL
        FROM CP_CALL CPC
        LEFT JOIN SOLISERV SOL
               ON SOL.CDFILIAL = '9999'
              AND SOL.NRSOLISERV = CPC.CALL_RELATIONSHIP 
              AND CPC.TYPE = 'S'
        LEFT JOIN TASK TAS
               ON TAS.ID = CPC.CALL_RELATIONSHIP 
              AND CPC.TYPE = 'I' 
              AND TAS.STATUS = 'A'
        LEFT JOIN CLASSIFICATION CLA
               ON CLA.ID = TAS.CLASSIFICATION
        LEFT JOIN ALLOCATION ALC
               ON ALC.TASK = TAS.ID
              AND ALC.TYPE = 'S'
        LEFT JOIN RESOURCE_T RES
               ON RES.ID = ALC.RESOURCE_T
             JOIN CLIENTE CLT
               ON CLT.CDCLIENTE = RES.EXTERNAL_CODE
               OR CLT.CDCLIENTE = SOL.CDCLIENTE
             JOIN SLACLIENTE_ALERT SCI
               ON SCI.CDCLIENTE = CLT.CDCLIENTE 
              AND SCI.CDGRUPFASE IN ('30', '13')
              AND (SCI.CDASSUNTO = CLA.CDASSUNTO OR SCI.CDASSUNTO = SOL.CDASSUNTO)
              AND SCI.CDCOMPLEXID = '02'
             JOIN SLACLIENTE_PARAM SLP
               ON SLP.CDCLIENTE = SCI.CDCLIENTE
        LEFT JOIN CLASSIFICATION CLA1
               ON CLA1.CDASSUNTO = SCI.CDASSUNTO
        LEFT JOIN PROJECT PRT 
               ON PRT.ID = TAS.PROJECT
        LEFT JOIN PRODUTO PRC
               ON PRC.CDPRODUTO = SOL.CDPRODCOMP
        LEFT JOIN EQUIPETRAB EQT
               ON EQT.CDEQUIPETRAB = PRC.CDEQUIPERESP
        LEFT JOIN OPERADOR OPR
               ON OPR.CDOPERADOR = EQT.CDOPERRESP
        LEFT JOIN RESOURCE_T RSO
               ON RSO.ORGANIZATION = OPR.NRORG
              AND RSO.EXTERNAL_CODE = OPR.CDOPERADOR
        LEFT JOIN PERMISSION POR
               ON POR.ORGANIZATION = RSO.ORGANIZATION
              AND POR.RESOURCE_T = RSO.ID
              AND NVL(POR.TYPE, 'R') = 'R'  
        LEFT JOIN V_STRUCTURE_TEK VST
               ON VST.ID_STRUCTURE = PRT.STRUCTURE
               OR VST.ID_STRUCTURE = POR.STRUCTURE
       WHERE CPC.DTHOMOLOGACAO IS NULL
         AND CPC.ID_SLA_CHECK = 'S' 
         AND (   
                (SCI.IDANTESDEPOIS = 'A' AND 
                                        (SCI.CDGRUPFASE = 30 AND CPC.QTSLA_TOT_TEK < CPC.QT_SLA_CONTRATO AND CPC.QTSLA_TOT_TEK >= CPC.QT_SLA_CONTRATO - SCI.QTHORASALERT
                                        OR SCI.CDGRUPFASE = 13 AND CPC.QTSLA_ESPECIFICACAO < CPC.QT_SLA_CONTRATO AND CPC.QTSLA_ESPECIFICACAO >= CPC.QT_SLA_CONTRATO - SCI.QTHORASALERT
                                        )
                )
              OR (SCI.IDANTESDEPOIS ='D' AND 
                                        (SCI.CDGRUPFASE = 30 AND CPC.QTSLA_TOT_TEK > CPC.QT_SLA_CONTRATO AND CPC.QTSLA_TOT_TEK >= CPC.QT_SLA_CONTRATO + SCI.QTHORASALERT
                                        OR SCI.CDGRUPFASE = 13 AND CPC.QTSLA_ESPECIFICACAO > CPC.QT_SLA_CONTRATO AND CPC.QTSLA_ESPECIFICACAO >= CPC.QT_SLA_CONTRATO + SCI.QTHORASALERT
                                        )
                )
            )
       ORDER BY CPC.NRCALL

SQL;
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query);

    }


}
